QGIS Application - Bug report #9395

WFS layers time out, even though the timeout is not reached

2014-01-21 07:23 AM - Jacob Madsen

Status: Closed

Priority: Normal

Assignee:

Category: Web Services clients/WFS

Affected QGIS version:2.10.0
Operating System:

Pull Request or Patch supplied:
Crashes QGIS or corrupls data:

Regression?: No
Easy fix?: No
Resolution:

Copied to github as #: 17993

Description

Whenever | open existing projects containing WFS layers, | often get errors like this in the log, and the layer is marked as "Invalid":

"Network request

http://wfs.brandsoft.dk/geoserver/wfs_service_stroeby/ows?SERVICE=WFS&#38;VERSION=1.0.0&#38; TYPENAME=wfs_service_str

eby:Strogby Afdeling&#38;&#38;REQUEST=DescribeFeatureType timed out"

| can then manually re-query the layer from the WFS server, and it loads up just fine. It seems to me, that WFS does not respect the value

"Network query timeout (ms)" in Options->Network, where the default is 60000, ie one minute, which should be more than enough.

Can somebody please verify this - or give another probably reason as for why this happens?

History

#1 - 2014-01-22 11:15 AM - Giovanni Manghi
- Priority changed from High to Normal

- Operating System deleted (Windows 32-bit)

- OS version deleted (7 and newer)

Yes, it happens many times and the timeout option does not seems to have any effect.

#2 - 2014-02-17 05:01 AM - Jacob Madsen

Could I get some feedback on this? Still reproduces from time to time on build commit:57dd877

#3 - 2014-02-18 02:20 AM - Jacob Madsen
- Assignee changed from Marco Hugentobler to Jiirgen Fischer

Hi Jurgen

As you seem to know the networking code of QGIS very well, could | get you to take a look at this? It's my only known remaining issue for 2.0 master. It

would be really, REALLY great, if something could be done about this.

Thanks in advance,
Jacob
http://wfs.brandsoft.dk/geoserver/wfs_service_stroeby/ows?SERVICE=WFS&#38;VERSION=1.0.0&#38;TYPENAME=wfs_service_stroeby:Strøby_Afdeling&#38;&#38;REQUEST=DescribeFeatureType
http://wfs.brandsoft.dk/geoserver/wfs_service_stroeby/ows?SERVICE=WFS&#38;VERSION=1.0.0&#38;TYPENAME=wfs_service_stroeby:Strøby_Afdeling&#38;&#38;REQUEST=DescribeFeatureType

#4 - 2014-02-18 06:00 AM - Matthias Kuhn
- Assignee changed from Jiirgen Fischer to Matthias Kuhn

I'm currently having a look at this. Assigning to myself to avoid doubled up work.

#5 - 2014-02-18 07:19 AM - Jacob Madsen
- Status changed from Open to Closed

I've not been able to fully determine, that is a QGIS issue and not a Geoserver issue. For that reason, I'll close this issue until | eventually see it again and

can provide more information.

#6 - 2015-02-04 05:49 AM - Jacob Madsen

Hello

I need to reopen this case. This issue still occurs frequently for specific users. I'm on QGIS 2.6 now, and the server is GeoServer 2.6.2. The WFS layers are
running against an Oracle 12c database with the newest JDBC driver available. | don't see what else can be updated in this setup.

When the user gets the timeout on the client, | have monitored Geoserver's log file. | can see, that the requests indeed are made. The problem is, that it

occurs sporadically and is not easy to reproduce.

Can somebody help here?

#7 - 2015-02-05 02:01 AM - Giovanni Manghi

Jacob Madsen wrote:

Hello

| need to reopen this case. This issue still occurs frequently for specific users. I'm on QGIS 2.6 now, and the server is GeoServer 2.6.2. The WFS

layers are running against an Oracle 12c database with the newest JDBC driver available. | don't see what else can be updated in this setup.

When the user gets the timeout on the client, | have monitored Geoserver's log file. | can see, that the requests indeed are made. The problem is,

that it occurs sporadically and is not easy to reproduce.

Can somebody help here?

does the issue surfaces by using other wfs clients? and older qgis releases?

#8 - 2015-02-09 06:24 AM - Jacob Madsen

As far as | know, we encountered this issue back as early as version 2.0, and it's been present since.

We have not tried other wfs-t clients, as I've been unable to find any really usable ones. uDig seems quite broken to me. Can you recommend any

alternatives?
#9 - 2015-02-09 12:12 PM - Giovanni Manghi
Jacob Madsen wrote:

As far as | know, we encountered this issue back as early as version 2.0, and it's been present since.

and in qgis 1.8 (or earlier)?

Can you recommend any alternatives?
gvsig has a wfs client.

#10 - 2015-02-11 07:16 AM - Jacob Madsen

Giovanni Manghi wrote:

Jacob Madsen wrote:

| As far as | know, we encountered this issue back as early as version 2.0, and it's been present since.
and in qgis 1.8 (or earlier)?

| Can you recommend any alternatives?

gvsig has a wfs client.

| tried gvSIG Desktop, but its WFS client doesn't seem to support services, which require username and password, so | can't use it. If | try against one of
my services, instead of asking for a username and password, | just get the message "Connection failed. Server redirected too many times (20)". Do you
know of other WFS-T clients | can try? | can't just allow open access to production data.
#11 - 2015-02-12 03:19 AM - Giovanni Manghi

I tried gvSIG Desktop, but its WFS client doesn't seem to support services, which require username and password, so | can't use it. If | try against

one of my services, instead of asking for a username and password, | just get the message "Connection failed. Server redirected too many times
(20)". Do you know of other WFS-T clients | can try? | can't just allow open access to production data.

kosmo gis seems to have a wfs client with authentication support.

#12 - 2015-11-27 09:55 AM - Miguel Penteado
- Assignee changed from Matthias Kuhn to Giovanni Manghi
- Status changed from Closed to Reopened

Dear Developers

| have experiencied same trouble. My configuration is that:
Client:
Server

machine
<POSTGRES/POSTGIS ===(WFS-Client)< QGIS 2.10>
9.3>===========(JDBC)==<Geo
Server 2.8
stable>(WFS-server)====

Linux Client==========
===============Linux
Localhost

| figured that wfs client timeout's happens on qgis 2.10 at 20 secs, if it don't get yet features from server (in my case: query started by geoserver on postgis

belongs 4 minutes before send results back to geoserver, and then, back to wfs client).

So a had tried to download sgml file from wfs server with a simple raw curl http client, somthing like that:

curl -X'GET' -H "™Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;0=0.8*" -H 'Accept-Encoding: deflate’ -H 'Accept-Language:
pt-BR,en-US;g=0.7,en;q=0.3" -H 'Connection: keep-alive' -H 'Host: myserver.com.br:8080" -H 'User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64;

rv:40.0) Gecko/20100101 Firefox/40.0' --cookie 'JSESSIONID=9742EBB3A203846020AA3D7F130CFB5C' --cookie

'_ga=GA1.3.1360557005.1435772510" --cookie 'csrftoken=FeHsf4ptLa5dZ7CGRFvuyxI2z8zMWIBh' --cookie
'LtpaToken=AAECAzU2NTgOODUSNTY10DU2N;jIDTj1NaWd1ZWwgU3VhcmV6IFhhdmllciBQZW50ZWFkby9PVT1TUC9PPUICROVKF79kMTMTO5yzUbnmdIK
UbnmdIK5e+qZXg=="'
'http://myserver.com.br:8080/geoserver/americana/ows?service=WFS&version=1.0.0&request=GetFeature&typeName=americana:americana-eixos' >

americana-eixos.xml

The curl result:
% Total % Received % Xferd Average Speed Time Time Time Current
Dload Upload Total Spent Left Speed
100476M 0476M 0 0 161k 0 --i----- 0:05:01 --:---- 11.2M

curl "wfs client" <-no-timeout--5 min-> geoserver

QGIS wfs client <----timeout--20 secs-> geoserver

In my suspects, there are some python code parameter in WFS client code on QGIS that sets timeouts if servers don't send any features in 20 secs (by

default). Timeout is on client side.

Best regards

Miguel Suez Xve Penteado
#13 - 2015-11-27 10:01 AM - Giovanni Manghi

- Affected QGIS version changed from 2.0.1 to 2.10.0

- Assignee deleted (Giovanni Manghi)

- Target version deleted (Future Release - High Priority)

#14 - 2016-01-16 12:28 PM - Jeremy Palmer

I think this issue can be best resolved by first respecting the server-side timeout setting. Currently the QGIS network timeout settings will cancel a query
even if server is still in progress. | think one option here is to Change the user defined client-side timeout setting option to allow users to turn it off. e.g value
of 0 = wait for server to timeout. In the content of the WFS provider its certainly best to let the server timeout, or let the user can cancel the request via the
WEFS progress dialog.

#15 - 2016-01-19 10:19 AM - Even Rouault

Regarding the 60s default timeout not being obvserved, | noticed it was ~ 20 seconds. This is because of an inconsistency in the default value of the

parameter :

../src/core/qgshttptransaction.h:  int networkTimeout() const { return mNetwork TimeoutMsec;}

../src/core/qgshttptransaction.cpp: mNetworkTimeoutMsec = s.value( "/qgis/networkAndProxy/network Timeout", "20000" ).tolnt();
../src/core/qgshttptransaction.cpp: mNetworkTimeoutMsec = s.value( "/qgis/networkAndProxy/network Timeout", "20000" ).tolnt();
../src/core/qgsnetworkaccessmanager.cpp: timer->start( s.value( "/qgis/networkAndProxy/network Timeout", "20000" ).toInt() );
../src/app/qgsoptions.cpp: mNetwork TimeoutSpinBox->setValue( mSettings->value( "/qgis/networkAndProxy/network Timeout", "60000" ).toInt() );
../src/app/qgsoptions.cpp: mSettings->setValue( "/qgis/networkAndProxy/networkTimeout", mNetwork TimeoutSpinBox->value() );
./src/app/qgisapp.cpp:  timer->start( s.value( "/qgis/networkAndProxy/networkTimeout", "20000" ).tolnt() );

Basically if you never override the value of the Ul, the network code will use 20s, but the Ul will display 60. A #define for the factory default would be better.

#16 - 2016-10-06 01:06 PM - Even Rouault
- Status changed from Reopened to Closed

| believe this was solved in 2.16
